#include<bits/stdc++.h>
using namespace std;
int c;
vector<int>v(200000);
void zameni(string &s, int n)
{
  if (s[n-1]=='1') s[n-1]='0';
  else s[n-1]='1';
}
int brniz(string s, int n)
{
  int duzniz=0;
  int bniz=0;
  int x=0;
  for (int i=0; i<n; i++)
  {
    if (s[i]=='1')
    {
      duzniz++;
    }
    else if (duzniz>=c) {
      bniz++;
      duzniz=0;
    }
    else {
      x++;
      bniz++;
      duzniz=0;
    }
  }
  return bniz*c+x;
}
int main()
{
  int n,q;
  cin >> n >> c >> q;
  string s;
  cin >> s;
  for (int i=0; i<q; i++)
  {
    int l,d;
    cin >> l >> d;
    for (int j=l; j<d; j++)
    {
      zameni(s,j);
    }
    int br0=0;
    for (int k=0; k<n; k++)
    {
      if (s[k]=='0') br0++;
    }
    if (c==n) 
    {
      v[i]=n-br0;
      continue;
    }
    if (c==1)
    {
      v[i]=n-br0;
    }
    else 
    {
      v[i]=brniz(s,n);
    }
  }
  for (int i=0; i<q; i++)
  {
    cout << v[i] << endl;
  }
  return 0;
}